<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.5"/>
<title>fwAccessControl: Privilege-checking functions</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">fwAccessControl
   &#160;<span id="projectnumber">8.4.1</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.5 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('group__PermissionFunctions.html','');});
</script>
<div id="doc-content">
<div class="header">
  <div class="headertitle">
<div class="title">Privilege-checking functions<div class="ingroups"><a class="el" href="group__API.html">Access Control library</a></div></div>  </div>
</div><!--header-->
<div class="contents">
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="member-group"></a>
Permission-related functions</h2></td></tr>
<tr><td class="ititle" colspan="2"><p><a class="anchor" id="amgrpd36069dc17404633ef9d4bd717349951"></a>see also the module <a class="el" href="group__PermissionFunctions.html">Permission manipulation functions</a> </p>
</td></tr>
<tr class="memitem:ga252941306ac100c33f2b55bd0055ff15"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__PermissionFunctions.html#ga252941306ac100c33f2b55bd0055ff15">fwAccessControl_HasUserAdminPrivilege</a> (dyn_string &amp;exceptionInfo, string user=&quot;&quot;, bool exceptionOnNotGranted=TRUE)</td></tr>
<tr class="separator:ga252941306ac100c33f2b55bd0055ff15"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga186ffa5c5f7fb2fdc4880079302bb0b2"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__PermissionFunctions.html#ga186ffa5c5f7fb2fdc4880079302bb0b2">fwAccessControl_HasGroupAdminPrivilege</a> (dyn_string &amp;exceptionInfo, string user=&quot;&quot;, bool exceptionOnNotGranted=TRUE)</td></tr>
<tr class="separator:ga186ffa5c5f7fb2fdc4880079302bb0b2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga2a8fd965ef03a3dcbd365fa2773e4720"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__PermissionFunctions.html#ga2a8fd965ef03a3dcbd365fa2773e4720">fwAccessControl_HasDomainAdminPrivilege</a> (dyn_string &amp;exceptionInfo, string user=&quot;&quot;, bool exceptionOnNotGranted=TRUE)</td></tr>
<tr class="separator:ga2a8fd965ef03a3dcbd365fa2773e4720"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gab83a70846ec8226518f65ea91177f86d"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__PermissionFunctions.html#gab83a70846ec8226518f65ea91177f86d">fwAccessControl_HasSystemAdminPrivilege</a> (dyn_string &amp;exceptionInfo, string user=&quot;&quot;, bool exceptionOnNotGranted=TRUE)</td></tr>
<tr class="separator:gab83a70846ec8226518f65ea91177f86d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga3e4f6acaf23bd3fda437f26bc0dd46f9"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__PermissionFunctions.html#ga3e4f6acaf23bd3fda437f26bc0dd46f9">fwAccessControl_getGroupPrivileges</a> (string groupName, dyn_string domainNames, dyn_string &amp;privileges, dyn_string &amp;exceptionInfo, bool recursively=FALSE)</td></tr>
<tr class="separator:ga3e4f6acaf23bd3fda437f26bc0dd46f9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga4d7c7a5f17a7b71a1c80d662a407bb72"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__PermissionFunctions.html#ga4d7c7a5f17a7b71a1c80d662a407bb72">fwAccessControl_updateGroupPrivileges</a> (string groupName, dyn_string newPrivileges, dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:ga4d7c7a5f17a7b71a1c80d662a407bb72"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga116a24fc314dd39217203d7d1d0916f5"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__PermissionFunctions.html#ga116a24fc314dd39217203d7d1d0916f5">fwAccessControl_getUserPrivileges</a> (string userName, dyn_string domainNames, dyn_string &amp;privileges, dyn_string &amp;exceptionInfo, bool strictRoleChecking=FALSE)</td></tr>
<tr class="separator:ga116a24fc314dd39217203d7d1d0916f5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga6fa78917bfc7ff6e851b2a36711db5df"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__PermissionFunctions.html#ga6fa78917bfc7ff6e851b2a36711db5df">fwAccessControl_checkUserPrivilege</a> (string userName, string domainName, string privilegeName, bool &amp;granted, dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:ga6fa78917bfc7ff6e851b2a36711db5df"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga849cae607bc8b26edce17ad209aa252c"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__PermissionFunctions.html#ga849cae607bc8b26edce17ad209aa252c">fwAccessControl_isGranted</a> (string domain_privilege, bool &amp;granted, dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:ga849cae607bc8b26edce17ad209aa252c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gac95e1354799d1e631bf7bb2402b1cd93"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__PermissionFunctions.html#gac95e1354799d1e631bf7bb2402b1cd93">fwAccessControl_getGroupsHavingPrivilege</a> (string domainName, string privName, dyn_string &amp;groups, dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:gac95e1354799d1e631bf7bb2402b1cd93"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga09ed5a20aa529024dd6e355700c64a08"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__PermissionFunctions.html#ga09ed5a20aa529024dd6e355700c64a08">fwAccessControl_getUsersHavingPrivilege</a> (string domainName, string privName, dyn_string &amp;users, dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:ga09ed5a20aa529024dd6e355700c64a08"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga66d146b3e996092c2041204935d5e393"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__PermissionFunctions.html#ga66d146b3e996092c2041204935d5e393">fwAccessControl_getPrivilegeNames</a> (string domainName, dyn_string &amp;privilegeNames, dyn_int &amp;privilegeIds, dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:ga66d146b3e996092c2041204935d5e393"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga14fb2630696df901e75c6345717263b3"><td class="memItemLeft" align="right" valign="top">dyn_string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__PermissionFunctions.html#ga14fb2630696df901e75c6345717263b3">fwAccessControl_getAllAccessRightNames</a> (dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:ga14fb2630696df901e75c6345717263b3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga2d5d0d6544a3f29d7df665f554333d71"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__PermissionFunctions.html#ga2d5d0d6544a3f29d7df665f554333d71">fwAccessControl_checkUserPrivilege_AuthFunc</a> (string userName, string domainName, string privilegeName, bool &amp;granted, dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:ga2d5d0d6544a3f29d7df665f554333d71"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga63a29e25c6bea4a61bef8366cff195e8"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ga63a29e25c6bea4a61bef8366cff195e8"></a>
private bool&#160;</td><td class="memItemRight" valign="bottom"><b>fwAccessControl_verifyUIManAndWSAuth</b> (string userName, string domainName, string privilegeName, dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:ga63a29e25c6bea4a61bef8366cff195e8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gabeec0bcb9e72f6118839544d59428f5b"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="gabeec0bcb9e72f6118839544d59428f5b"></a>
private void&#160;</td><td class="memItemRight" valign="bottom"><b>fwAccessControl_checkUserPrivilege_AuthFunc_Builtin</b> (string userName, string domainName, string privilegeName, bool &amp;granted, dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:gabeec0bcb9e72f6118839544d59428f5b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga860128edb5329590c6f2c1eeaa483d69"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ga860128edb5329590c6f2c1eeaa483d69"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>fwAccessControl_checkUserPrivilege_AuthFastFunc</b> (string userName, string domainName, string privilegeName, bool &amp;granted, dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:ga860128edb5329590c6f2c1eeaa483d69"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaf129b8b4003e49c54fe0fa810582677b"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__PermissionFunctions.html#gaf129b8b4003e49c54fe0fa810582677b">fwAccessControl_setPrivilegeNames</a> (string domainName, dyn_string privilegeNames, dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:gaf129b8b4003e49c54fe0fa810582677b"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<h2 class="groupheader">Function Documentation</h2>
<a class="anchor" id="ga252941306ac100c33f2b55bd0055ff15"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool fwAccessControl_HasUserAdminPrivilege </td>
          <td>(</td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>user</em> = <code>&quot;&quot;</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>exceptionOnNotGranted</em> = <code>TRUE</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">check if user has User Administration privilege
</pre><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">exceptionInfo</td><td>standard error-handling variable </td></tr>
    <tr><td class="paramname">user</td><td>(optional) the name of the user for which privilege is checked; by default (empty string) - current user. </td></tr>
    <tr><td class="paramname">exceptionOnNotGranted</td><td>if true, also raises exception when the user has no privilege </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>TRUE if the requested user has User Administration privilege </dd></dl>

</div>
</div>
<a class="anchor" id="ga186ffa5c5f7fb2fdc4880079302bb0b2"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool fwAccessControl_HasGroupAdminPrivilege </td>
          <td>(</td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>user</em> = <code>&quot;&quot;</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>exceptionOnNotGranted</em> = <code>TRUE</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">check if user has Group Administration privilege
</pre><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">exceptionInfo</td><td>standard error-handling variable </td></tr>
    <tr><td class="paramname">user</td><td>(optional) the name of the user for which privilege is checked; by default (empty string) - current user. </td></tr>
    <tr><td class="paramname">exceptionOnNotGranted</td><td>if true, also raises exception when the user has no privilege </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>TRUE if the requested user has Group Administration privilege </dd></dl>

</div>
</div>
<a class="anchor" id="ga2a8fd965ef03a3dcbd365fa2773e4720"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool fwAccessControl_HasDomainAdminPrivilege </td>
          <td>(</td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>user</em> = <code>&quot;&quot;</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>exceptionOnNotGranted</em> = <code>TRUE</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">check if user has Domain Administration privilege
</pre><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">exceptionInfo</td><td>standard error-handling variable </td></tr>
    <tr><td class="paramname">user</td><td>(optional) the name of the user for which privilege is checked; by default (empty string) - current user. </td></tr>
    <tr><td class="paramname">exceptionOnNotGranted</td><td>if true, also raises exception when the user has no privilege </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>TRUE if the requested user has Domain Administration privilege </dd></dl>

</div>
</div>
<a class="anchor" id="gab83a70846ec8226518f65ea91177f86d"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool fwAccessControl_HasSystemAdminPrivilege </td>
          <td>(</td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>user</em> = <code>&quot;&quot;</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>exceptionOnNotGranted</em> = <code>TRUE</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">check if user has System Administration (root) privilege
</pre><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">exceptionInfo</td><td>standard error-handling variable </td></tr>
    <tr><td class="paramname">user</td><td>(optional) the name of the user for which privilege is checked; by default (empty string) - current user. </td></tr>
    <tr><td class="paramname">exceptionOnNotGranted</td><td>if true, also raises exception when the user has no privilege </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>TRUE if the requested user has System Administration privilege </dd></dl>

</div>
</div>
<a class="anchor" id="ga3e4f6acaf23bd3fda437f26bc0dd46f9"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void fwAccessControl_getGroupPrivileges </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>groupName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string&#160;</td>
          <td class="paramname"><em>domainNames</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>privileges</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>recursively</em> = <code>FALSE</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">get the list of privileges granted to a group
</pre><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">groupName</td><td>specifies the group name </td></tr>
    <tr><td class="paramname">domainNames</td><td>if empty, all domains are searched, including system domain </td></tr>
    <tr><td class="paramname">privileges</td><td>on return contains the list of privileges </td></tr>
    <tr><td class="paramname">exceptionInfo</td><td>standard error-handling variable </td></tr>
    <tr><td class="paramname">recursively</td><td>(optional, default FALSE); determines if group hierarchy should be traversed recursively to extract all privileges </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ga4d7c7a5f17a7b71a1c80d662a407bb72"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void fwAccessControl_updateGroupPrivileges </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>groupName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string&#160;</td>
          <td class="paramname"><em>newPrivileges</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">sets (updates) the privileges of a group
</pre><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">groupName</td><td>specifies the group name </td></tr>
    <tr><td class="paramname">newPrivileges</td><td>contains the list of new privileges, encoded as "domain:privilege" strings </td></tr>
    <tr><td class="paramname">exceptionInfo</td><td>standard error-handling variable </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ga116a24fc314dd39217203d7d1d0916f5"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void fwAccessControl_getUserPrivileges </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>userName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string&#160;</td>
          <td class="paramname"><em>domainNames</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>privileges</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>strictRoleChecking</em> = <code>FALSE</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>get privileges of specified user for a domain</p>
<p>This function returns the list of privileges for a specified user in a specified domain (or a list of domains) </p>

</div>
</div>
<a class="anchor" id="ga6fa78917bfc7ff6e851b2a36711db5df"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void fwAccessControl_checkUserPrivilege </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>userName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>domainName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>privilegeName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool &amp;&#160;</td>
          <td class="paramname"><em>granted</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">check if specific user has permission in a domain
</pre><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">userName</td><td>user name for which privileges are checked; empty string: get current user </td></tr>
    <tr><td class="paramname">domainName</td><td>domain name in which privilege is checked </td></tr>
    <tr><td class="paramname">privilegeName</td><td>privilege name queried </td></tr>
    <tr><td class="paramname">granted</td><td>on return will contain TRUE if user has the privilege, FALSE otherwise </td></tr>
    <tr><td class="paramname">exceptionInfo</td><td>standard error-handling variable</td></tr>
  </table>
  </dd>
</dl>
<dl class="section note"><dt>Note</dt><dd>There is a peculiar behaviour in PVSS access control functions for domains, i.e. when calling getUserPermissionForArea, the access is granted ONLY if user has specified access-bit set for area AND the same bit set also in system domain! That means we need to have (at least) bits 21-28 of system SET TO 1.</dd>
<dd>
if <code>userName</code> is NULL (ie get current user), then the function will also take into account the current workstation/manager authorization masks, which allows to restrict certain privileges to certain workstations; this will however not work if a custom authorization function is specified. </dd></dl>

</div>
</div>
<a class="anchor" id="ga849cae607bc8b26edce17ad209aa252c"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void fwAccessControl_isGranted </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>domain_privilege</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool &amp;&#160;</td>
          <td class="paramname"><em>granted</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">This function returns whether the current user has been granted a certain privilege.
</pre><p>Modification History: None <br/>
Constraints: None <br/>
Usage: JCOP framework internal <br/>
PVSS manager usage: VISION <br/>
 </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">domain_privilege</td><td>string that contains the domain, the privilege is seeked in, concatenate via : with the name of the domain </td></tr>
    <tr><td class="paramname">granted</td><td>boolean that will contain the result of the query </td></tr>
    <tr><td class="paramname">exceptionInfo</td><td>dyn_string for JCOP Fw exception handling</td></tr>
  </table>
  </dd>
</dl>
<dl class="section see"><dt>See Also</dt><dd><a class="el" href="group__PermissionFunctions.html#ga6fa78917bfc7ff6e851b2a36711db5df">fwAccessControl_checkUserPrivilege</a> <a class="el" href="group__PermissionFunctions.html#ga116a24fc314dd39217203d7d1d0916f5">fwAccessControl_getUserPrivileges</a> </dd></dl>

</div>
</div>
<a class="anchor" id="gac95e1354799d1e631bf7bb2402b1cd93"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void fwAccessControl_getGroupsHavingPrivilege </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>domainName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>privName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>groups</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">get the list of groups that hold specific privilege
</pre><p>Note: the function also looks up through each groups' subgroups to resolve all privileges... </p>

</div>
</div>
<a class="anchor" id="ga09ed5a20aa529024dd6e355700c64a08"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void fwAccessControl_getUsersHavingPrivilege </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>domainName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>privName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>users</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>get the list of users that hold specific privilege </p>

</div>
</div>
<a class="anchor" id="ga66d146b3e996092c2041204935d5e393"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void fwAccessControl_getPrivilegeNames </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>domainName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>privilegeNames</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_int &amp;&#160;</td>
          <td class="paramname"><em>privilegeIds</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>get the names (and ids) of privileges in a specifc domain </p>

</div>
</div>
<a class="anchor" id="ga14fb2630696df901e75c6345717263b3"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">dyn_string fwAccessControl_getAllAccessRightNames </td>
          <td>(</td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>get the list of all valid access right names from all domains </p>

</div>
</div>
<a class="anchor" id="ga2d5d0d6544a3f29d7df665f554333d71"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void fwAccessControl_checkUserPrivilege_AuthFunc </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>userName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>domainName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>privilegeName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool &amp;&#160;</td>
          <td class="paramname"><em>granted</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Default authorization-checking routine </p>

</div>
</div>
<a class="anchor" id="gaf129b8b4003e49c54fe0fa810582677b"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void fwAccessControl_setPrivilegeNames </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>domainName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string&#160;</td>
          <td class="paramname"><em>privilegeNames</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>sets the list of privilege names for a domain </p>

</div>
</div>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.5 </li>
  </ul>
</div>
</body>
</html>
